#!/usr/bin/python
# -*- encoding: utf-8; py-indent-offset: 4 -*-
#
# Interface error details metrics plugin
#
# Author: Th.L.
# Date  : 2020-04-03
#

#####################################################################################################################
#
# define units
#
#####################################################################################################################


######################################################################################################################
#
# map perfdata to metric, not really necessary but makes sure to use the right metrics
#
######################################################################################################################


check_metrics['check_mk-iferrordetails'] = {
    'dot3statsalignmenterrors': {'name': 'iferrordetails_dot3statsalignmenterrors',},
    'dot3statsfcserrors': {'name': 'iferrordetails_dot3statsfcserrors',},
    'dot3statssinglecollisionframes': {'name': 'iferrordetails_dot3statssinglecollisionframes',},
    'dot3statsmultiplecollisionframes': {'name': 'iferrordetails_dot3statsmultiplecollisionframes',},
    'dot3statssqetesterrors': {'name': 'iferrordetails_dot3statssqetesterrors',},
    'dot3statsdeferredtransmissions': {'name': 'iferrordetails_dot3statsdeferredtransmissions',},
    'dot3statslatecollisions': {'name': 'iferrordetails_dot3statslatecollisions',},
    'dot3statsexcessivecollisions': {'name': 'iferrordetails_dot3statsexcessivecollisions',},
    'dot3statsinternalmactransmiterr': {'name': 'iferrordetails_dot3statsinternalmactransmiterr',},
    'dot3statscarriersenseerrors': {'name': 'iferrordetails_dot3statscarriersenseerrors',},
    'dot3statsframetoolongs': {'name': 'iferrordetails_dot3statsframetoolongs',},
    'dot3statsinternalmacreceiveerrors': {'name': 'iferrordetails_dot3statsinternalmacreceiveerrors',},
    'dot3statssymbolerrors': {'name': 'iferrordetails_dot3statssymbolerrors',},
}

#####################################################################################################################
#
# define metrics for perfdata
#
#####################################################################################################################


metric_info['iferrordetails_dot3statsalignmenterrors'] = {
    'title' : _('Alignment errors'),
    'unit'  : 'count',
    'color' : '11/a',
}
metric_info['iferrordetails_dot3statsfcserrors'] = {
    'title' : _('FCS errors'),
    'unit'  : 'count',
    'color' : '12/a',
}
metric_info['iferrordetails_dot3statssqetesterrors'] = {
    'title' : _('SQE test errors'),
    'unit'  : 'count',
    'color' : '15/a',
}
metric_info['iferrordetails_dot3statsdeferredtransmissions'] = {
    'title' : _('Deferred transmissions'),
    'unit'  : 'count',
    'color' : '16/a',
}
metric_info['iferrordetails_dot3statsinternalmactransmiterr'] = {
    'title' : _('intern. MAC transmit errors'),
    'unit'  : 'count',
    'color' : '23/a',
}
metric_info['iferrordetails_dot3statsinternalmacreceiveerrors'] = {
    'title': _('intern. MAC receive errors'),
    'unit': 'count',
    'color': '26/a',
}
metric_info['iferrordetails_dot3statscarriersenseerrors'] = {
    'title' : _('Carrier sense errors'),
    'unit'  : 'count',
    'color' : '24/a',
}
metric_info['iferrordetails_dot3statsframetoolongs'] = {
    'title' : _('Frame too long'),
    'unit'  : 'count',
    'color' : '25/a',
}

metric_info['iferrordetails_dot3statssymbolerrors'] = {
    'title' : _('Symbol errors'),
    'unit'  : 'count',
    'color' : '31/a',
}
metric_info['iferrordetails_dot3statssinglecollisionframes'] = {
    'title' : _('Single collisions'),
    'unit'  : 'count',
    'color' : '13/a',
}
metric_info['iferrordetails_dot3statsmultiplecollisionframes'] = {
    'title' : _('Multiple collisions'),
    'unit'  : 'count',
    'color' : '23/a',
}
metric_info['iferrordetails_dot3statslatecollisions'] = {
    'title': _('Late collisions'),
    'unit': 'count',
    'color': '33/a',
}
metric_info['iferrordetails_dot3statsexcessivecollisions'] = {
    'title': _('Excessive collisions'),
    'unit': 'count',
    'color': '43/a',
}

######################################################################################################################
#
# how to graph perdata
#
######################################################################################################################

graph_info.append({
    'title': _('Interface error details'),
    'metrics': [
        ('iferrordetails_dot3statsalignmenterrors', 'line'),
        ('iferrordetails_dot3statscarriersenseerrors', 'line'),
        ('iferrordetails_dot3statsdeferredtransmissions', 'line'),
        ('iferrordetails_dot3statsfcserrors', 'line'),
        ('iferrordetails_dot3statsframetoolongs', 'line'),
        ('iferrordetails_dot3statsinternalmacreceiveerrors', 'line'),
        ('iferrordetails_dot3statsinternalmactransmiterr', 'line'),
        ('iferrordetails_dot3statssqetesterrors', 'line'),
        ('iferrordetails_dot3statssymbolerrors', 'line'),
    ],
})

graph_info.append({
    'title': _('Interface collisions'),
    'metrics': [
        ('iferrordetails_dot3statssinglecollisionframes', 'line'),
        ('iferrordetails_dot3statsmultiplecollisionframes', 'line'),
        ('iferrordetails_dot3statslatecollisions', 'line'),
        ('iferrordetails_dot3statsexcessivecollisions', 'line'),
    ],
})
######################################################################################################################
#
# define perf-o-meter
#
######################################################################################################################

